DEFINT A-Z
DIM Address AS DWORD	' used as a code pointer

CLS
PRINT
PRINT "Enter your first name: ";

Address = 0   ' no need to validate the name
Row% = CSRLIN
Col% = POS
MaxLen% = 15
Temp$ = GetInput$(Row%, Col%, MaxLen%, Address)

PRINT
PRINT "Hi "; Temp$

PRINT
PRINT "Enter the state you live in: ";

Address = CODEPTR32(GoodState%)
Row% = CSRLIN
Col% = POS
MaxLen% = 2
Temp$ = GetInput$(Row%, Col%, MaxLen%, Address)

PRINT
PRINT "Enter your birthday: ";

Address = CODEPTR32(GoodDate)
Row% = CSRLIN
Col% = POS
MaxLen% = 8
Temp$ = GetInput$(Row%, Col%, MaxLen%, Address)

' Validate the state code
FUNCTION GoodState%(Text$)	' must be an integer function
  Text$ = UCASE$(Text$)
  ' only check western US states
  IF INSTR(Text$, ANY "AZ CA NV OR WA ID UT") THEN
    GoodState% = -1	' return true
  ELSE
    BEEP	' not a western state
    GoodState% = 0	' return false
  END IF
END FUNCTION

' Make sure they were born in March
FUNCTION GoodDate%(Text$)	' must be an integer function
  IF VAL(LEFT$(Text$,2)) = 3 THEN
    GoodDate% = -1	' return true
  ELSE
    BEEP	' must be born in March
    GoodDate% = 0	' return false
  END IF
END FUNCTION


' Generic input routine with data validation

' Row% = row at which to get input
' Col% = column at which to get input
' MaxLength% = maximum length of input string
' CheckData = code pointer to data validation function (0 if no validation required)

FUNCTION GetInput$(Row%, Col%, MaxLength%, BYVAL CheckData AS DWORD)

  OldX% = POS : OldY% = CSRLIN : RetVal% = 0

  DO
    LOCATE Row%, Col%, 1	' turn cursor on
    PRINT UserInput$;
    WHILE NOT INSTAT : WEND
    C$ = INKEY$
    SELECT CASE C$
      CASE CHR$(8)	' Backspace
        IF LEN(UserInput$) THEN	' if characters, delete one
          UserInput$ = LEFT$(UserInput$, LEN(UserInput$) - 1)
          LOCATE Row%, Col%, 0	' turn cursor off
          PRINT UserInput$; " ";	' erase deleted char from the screen
        END IF
      CASE CHR$(13)	' Enter; end loop
        IF CheckData THEN
          CALL DWORD CheckData BDECL (UserInput$)
          ! mov RetVal%, AX	; put return value in temp variable
          IF RetVal% THEN	' if it's non-zero, data is good
            EXIT LOOP
          END IF
        ELSE
          EXIT LOOP
        END IF
      CASE ELSE
        IF (ASCII(C$) > 31) AND (LEN(UserInput$) < MaxLength%) THEN
          UserInput$ = UserInput$ + C$	' add new character to the string
        END IF
    END SELECT
  LOOP

  LOCATE Row%, Col%, 0	' turn off cursor
  PRINT UserInput$; SPACE$(MaxLength% - LEN(UserInput$))
  GetInput$ = UserInput$

END FUNCTION
